
// Matrici

public class Esempio1 {
	
	static void stampaMatrice(int[][] m) {
		int i,j;
		for (i = 0 ; i < m.length ; i++) {
			for (j = 0 ; j < m[i].length ; j++) {
				System.out.print(m[i][j] + "   ");
			}
			System.out.println();  // Vai a capo
		}
	}

	public static void main(String[] args) {
		
		// Le matrici in Java sono "vettori di vettori".
		int[][] m;
		m = new int[3][]; // 3 righe

		m[0] = new int[4];  // 4 colonne
		m[1] = new int[4];  // 4 colonne
		m[2] = new int[4];  // 4 colonne
		 
		// Si potrebbe anche usare un for per allocare le singole righe.
		// C'è comunque un modo ancora più semplice, che vediamo tra poco.
		
		// Inizializziamo la matrice
		int i,j;
		for (i = 0 ; i < m.length ; i++) {
			for (j = 0 ; j < m[i].length ; j++) {
				// m[i][j] è l'elemento in riga i e colonna j
				m[i][j] = 10*i+j;
			}
		}
		// Si noti come m.length sia il numero di righe, e m[i].length
		// la lunghezza della righa i, cioè il numero di colonne.
		
		// Stampiamo
		stampaMatrice(m);
		
		// Esiste anche un modo più breve per allocare l'intera matrice.
		int [][] m2;
		m2 = new int[3][4];
		// Questo è perfettamente equivalente a fare tutte le new che abbiamo
		// fatto sopra manualmente.
		
		
		for (i = 0 ; i < m.length ; i++) {
			for (j = 0 ; j < m[i].length ; j++) {
				// m[i][j] è l'elemento in riga i e colonna j
				m2[i][j] = 100*j+i;
			}
		}
		
		System.out.println("--------------");
		stampaMatrice(m2);
		System.out.println("--------------");
		
		// Esercizio 1.
		// Si sviluppi una funzione
		//    static int[][] somma(int[][] m1, int[][] m2)
		// che calcoli la somma delle due matrici m1 e m2.
		
		// Esercizio 2.
		// Si sviluppi una funzione
		//    static int[][] trasposta(int[][] m)
		// che calcoli la trasposta della matrice m.
		
	}

}
